#
#  GNU Makefile for Waterloo TCP sample applications
#  Gisle Vanem 1997
#
#  Target:
#     GNU C 2.7+  (djgpp2 Dos extender)
#             

.SUFFIXES: .exe .pro

# Set to 1 to make a profiling version
#
PROFILE = 0

#
# Use YAMD malloc debugger (for developement versions only)
#
USE_YAMD=0

#
# Set to 1 to make DPMI-host (cwsdstub.exe) contained in .exe-file
#
DPMI_STUB = 0

INC_DIR = ../inc
WATTLIB = ../lib/libwatt.a
EXTRAS  = tiny.c

CC      = gcc
CFLAGS  = -Wall -g -O2 -gcoff -I$(INC_DIR) #-s # strip symbols from .exe

PROGS   = ping.exe    popdump.exe  rexec.exe   tcpinfo.exe cookie.exe \
          daytime.exe dayserv.exe  finger.exe  host.exe    lpq.exe    \
          lpr.exe     ntime.exe    ph.exe      stat.exe    htget.exe  \
          revip.exe   tracert.exe  tcptalk.exe vlsm.exe    whois.exe  \
          bping.exe   uname.exe    blather.exe lister.exe

all: $(PROGS)
	@echo Protected-mode (djgpp2) binaries done

ifeq ($(USE_YAMD),1)
  CFLAGS += -DYAMD_VERSION=\"0.32\" -Wl,--wrap,malloc,--wrap,realloc,--wrap,free
  EXTRAS += yamd.c
endif

%.exe: %.c ../lib/libwatt.a
ifeq ($(PROFILE),1)
	$(CC) $(CFLAGS) -pg $*.c $(EXTRAS) $(WATTLIB) -o $*.pro
	stubify $*.pro
        #
        # run "prog.exe [args]" as usual, then generate profile by
        # "gprof prog.pro > prog.res"
        #
else
ifeq ($(DPMI_STUB),1)
	$(CC) $(CFLAGS) $*.c $(EXTRAS) $(WATTLIB) -o $*
	@copy /b $(subst /,\,$(DJDIR))\bin\cwsdstub.exe + $* $*.exe
	@del $*
else
	$(CC) $(CFLAGS) $*.c $(EXTRAS) $(WATTLIB) -o $*.exe
endif
endif

$(PROGS): $(WATTLIB)

clean:
	rm -f *.o
