/*
 *  Reverse IP lookup: given a set of IP addresses, resolves
 *  the hostnames
 *
 *  G.Vanem <giva@bgnett.no>. Created 13-Sep-96
 */

#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <tcp.h>
#include <netdb.h>

#if defined(__SMALL__) && !(defined(__DMC__) & defined(DOS386))
#error SMALL model not supported
#endif

int main (int argc, char **argv)
{
  int i = 1;

  if (argc < 2)
  {
    printf ("Usage: %s [-d] ip-address(es) ..\n",argv[0]);
    return (0);
  }

  if (!strnicmp(argv[i],"-d",2))
  {
    i++;
    tcp_set_debug_state(2);
    dbug_init();
  }
  sock_init();

  while (i < argc)
  {
    struct hostent *h;
    char  *ip   = argv[i++];
    DWORD  addr = inet_aton (ip, NULL);

    if (addr == INADDR_ANY)
    {
      printf ("`%s' is not a valid IP-address\n",ip);
      continue;
    }
    printf ("Looking up %s..", ip);
    fflush (stdout);

    h = gethostbyaddr ((char*)&addr, sizeof(addr), AF_INET);
    printf ("\r%-15.15s: hostname is `%s'\n",
            ip, h ? h->h_name : "* unknown *");
  }
  return (0);
}
